############################################################################
# Copyright (C) 2002 David Lucardi
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,USA.
############################################################################
# File  : fichier.php
# Author  : David Lucardi
#           mailto: DavidLucardi@aol.com
# Date    : 26/04/2002
# Licence : GNU/GPL Version 2 ou plus
#
# Description:
# ------------
#
# @version    $Id: associations.tcl,v 1.6 2004/05/13 16:22:52 david Exp $
# @author     David Lucardi
# @project
# @copyright  David Lucardi 26/04/2002
#
#
#########################################################################
#!/bin/sh
#associations.tcl
# Licence : GNU/GPL Version 2 ou plus
# \
exec wish "$0" ${1+"$@"}

global basedir Homeconf plateforme sound
set plateforme $tcl_platform(platform)
set ident $tcl_platform(user)

source fonts.tcl
source path.tcl
source msg.tcl

init $plateforme
inithome
initlog $plateforme $ident
changehome

#wm resizable . 0 0
#on place la fenetre en haut  gauche
wm geometry . +0+0
. configure -background #ffff80

###########################################
proc interface {} {

global Home basedir sysFont progaide plateforme listacti sound baseHome prof abuledu
variable repert
variable repertcat
variable demarre
variable police

set listacti 1\0401\0401\0401\0401\0401\0401\0401\0401\0401\0401\0401\0401\0401\0401\0401\0401\0401\0401
set f [open [file join $baseHome reglages associations.conf] "r"]
set tmp [gets $f]
set police [gets $f]
close $f


if {$tmp == "none"} {
set demarre "Aucune"
} else {
set ext .dat
set demarre [string map {.cat ""} $tmp]
if {[catch {set f [open [file join $Home categorie $repertcat $demarre$ext] "r"]}] != 1} {
set listacti [lindex [gets $f] 1]
}
}

set listacti [string map {0 disabled 1 normal} $listacti]
catch {destroy .menu}
catch {destroy .wleft}
catch {destroy .wcenter}
catch {destroy .wright}

menu .menu -tearoff 0

# Creation du menu Fichier
menu .menu.fichier -tearoff 0
.menu add cascade -label [mc {Fichier}] -menu .menu.fichier

if {($abuledu == 0) || ($repert==0) || ($prof==1)} {
.menu.fichier add command -label [mc {Editeur}] -command "lanceappli editeur.tcl 1"
} else {
.menu.fichier add command -label [mc {Editeur}] -command "lanceappli editeur.tcl 1" -state disabled
}
.menu.fichier add command -label [mc {Bilans}] -command "lanceappli bilan.tcl 1"
.menu.fichier add sep
.menu.fichier add command -label [mc {Quitter}] -command exit

menu .menu.option -tearoff 0
.menu add cascade -label [mc {Options}] -menu .menu.option

menu .menu.option.police -tearoff 0 

.menu.option add cascade -label [mc {Police}] -menu .menu.option.police


set listedebonnespolices {Arial {Arial Black} courier {Cataneo BT} helvetica {Lucida Handwriting} times {Times New Roman}}
foreach i [lsort [font families]] {
      if {[lsearch $listedebonnespolices $i] != -1} {
.menu.option.police add radio -label $i -variable police -command "setpolice"

     }   
    }

#if {[catch {package require snack}]} {
#} else {
#.menu.option add command -label [mc {Gestion du son}] -command "lanceappli gestionson.tcl 1"
#}

set ext .msg
menu .menu.option.lang -tearoff 0 
.menu.option add cascade -label "[mc {Langue}]" -menu .menu.option.lang

foreach i [glob [file join  $basedir msgs *$ext]] {
set langue [string map {.msg ""} [file tail $i]]
.menu.option.lang add radio -label $langue -variable langue -command "setlang $langue"
}

menu .menu.option.repbase -tearoff 0 
.menu.option add cascade -label [mc {Repertoire categories}] -menu .menu.option.repbase
catch {
foreach i [lsort [glob [file join $Home categorie cat_*]]] {
.menu.option.repbase add radio -label [file tail $i] -variable repertcat -value [file tail $i] -command "changerepbasecat [file tail $i] \n interface"
}
}

menu .menu.option.repwork -tearoff 0 
.menu.option add cascade -label [mc {Repertoire de travail}] -menu .menu.option.repwork 
.menu.option.repwork add radio -label [mc {Individuel}] -variable repert -value 0 -command "changeinterface"
.menu.option.repwork add radio -label [mc {Commun}] -variable repert -value 1 -command "changeinterface"


menu .menu.action -tearoff 0
.menu add cascade -label [mc {Activites}] -menu .menu.action
menu .menu.action.m1 -tearoff 0

catch {
.menu.action add radio -label "Aucune" -variable demarre -command "changecatedefaut"
foreach i [lsort [glob [file join $Home categorie $repertcat *.cat]]] {
if {([string first non_ [file tail [lindex [split [lindex [split $i /] end] .] 0]]] != 0) && ([string match {[0-9]} [file tail [string index [lindex [split [lindex [split $i /] end] .] 0] end ]]] != 1)} {
.menu.action add radio -label [file tail [lindex [split [lindex [split $i /] end] .] 0]] -variable demarre -command "changecatedefaut"
}
}
}

if {$plateforme == "windows"} {
.menu add command -label [mc {Utilisateur}] -command "setwindowsusername"
}

menu .menu.aide -tearoff 0
.menu add cascade -label "Aide" -menu .menu.aide
#set fichier [file join $basedir aide index.htm]
set fichier [file join [pwd] aide index.htm]
.menu.aide add command -label [mc {Aide}] -command "exec $progaide file:$fichier &"
#.menu.aide add command -label [mc {Aide}] -command "exec $progaide \042$fichier\042 &"
.menu.aide add command -label [mc { propos ...}] -command "source apropos.tcl"

. configure -menu .menu


#######################################################################"
. configure -background blue
frame .wleft -background blue -height 300 -width 200
pack .wleft -side left
if {$sound != 0} {
label .wleft.a1 -text [mc {Entendre}] -background #ff9f80 -font $sysFont(s)
grid .wleft.a1 -row 0 -column 0 -sticky news
}
label .wleft.a2 -text [mc {Voir}] -background #ffff80 -font $sysFont(s)
grid .wleft.a2 -row 0 -column 1 -sticky news
label .wleft.a3 -text [mc {Reconnaitre}] -background #ff9f80 -font $sysFont(s)
grid .wleft.a3 -row 0 -column 2 -columnspan 2 -sticky news
label .wleft.a4 -text [mc {Combiner}] -background #ffff80 -font $sysFont(s)
grid .wleft.a4 -row 0 -column 4 -sticky news
label .wleft.a5 -text [mc {Ecrire}] -background #ff9f80 -font $sysFont(s)
grid .wleft.a5 -row 0 -column 5 -sticky news
if {$sound != 0} {

button .wleft.b11 -image [image create photo -file sysdata/b17.jpg] -background #ffff80 -command "lanceappli associe15.tcl 1" -bd 4 -height 90 -width 90
grid .wleft.b11 -row 1 -column 0 -sticky news -padx 3 -pady 3
.wleft.b11 configure -state [lindex $listacti 0]
button .wleft.b12 -image [image create photo -file sysdata/b18.jpg] -background #ffff80 -command "lanceappli associe16.tcl 1" -bd 4 -height 90 -width 90
grid .wleft.b12 -row 2 -column 0 -sticky news -padx 3 -pady 3
.wleft.b12 configure -state [lindex $listacti 1]
button .wleft.b13 -image [image create photo -file sysdata/b19.jpg] -background #ffff80 -command "lanceappli associe17.tcl 1" -bd 4 -height 90 -width 90
grid .wleft.b13 -row 3 -column 0 -sticky news -padx 3 -pady 3
.wleft.b13 configure -state [lindex $listacti 2]
}
button .wleft.b21 -image [image create photo -file sysdata/b7.jpg] -background #ffff80 -command "lanceappli associe10.tcl 1" -bd 4 -height 90 -width 90
grid .wleft.b21 -row 1 -column 1 -sticky news -padx 3 -pady 3
.wleft.b21 configure -state [lindex $listacti 3]
button .wleft.b22 -image [image create photo -file sysdata/b8.jpg] -background #ffff80 -command "lanceappli associe13.tcl 1" -bd 4 -height 90 -width 90
grid .wleft.b22 -row 2 -column 1 -sticky news -padx 3 -pady 3
.wleft.b22 configure -state [lindex $listacti 4]
button .wleft.b23 -image [image create photo -file sysdata/b13.jpg] -background #ffff80 -command "lanceappli associe9.tcl 1" -bd 4 -height 90 -width 90
grid .wleft.b23 -row 3 -column 1 -sticky news -padx 3 -pady 3
.wleft.b23 configure -state [lindex $listacti 5]
button .wleft.b31 -image [image create photo -file sysdata/b1.jpg] -background #ffff80 -command "lanceappli associe1.tcl 1" -bd 4 -height 90 -width 90
grid .wleft.b31 -row 1 -column 2 -sticky news -padx 3 -pady 3
.wleft.b31 configure -state [lindex $listacti 6]
button .wleft.b32 -image [image create photo -file sysdata/b2.jpg] -background #ffff80 -command "lanceappli associe1.tcl 2" -bd 4 -height 90 -width 90
grid .wleft.b32 -row 2 -column 2 -sticky news -padx 3 -pady 3
.wleft.b32 configure -state [lindex $listacti 7]
button .wleft.b33 -image [image create photo -file sysdata/b3.jpg] -background #ffff80 -command "lanceappli associe2.tcl 1" -bd 4 -height 90 -width 90
grid .wleft.b33 -row 3 -column 2 -sticky news -padx 3 -pady 3
.wleft.b33 configure -state [lindex $listacti 8]
button .wleft.b34 -image [image create photo -file sysdata/b4.jpg] -background #ffff80 -command "lanceappli associe2.tcl 2" -bd 4 -height 90 -width 90
grid .wleft.b34 -row 4 -column 2 -sticky news -padx 3 -pady 3
.wleft.b34 configure -state [lindex $listacti 9]
button .wleft.b41 -image [image create photo -file sysdata/b9.jpg] -background #ffff80 -command "lanceappli associe3.tcl 1" -bd 4 -height 90 -width 90
grid .wleft.b41 -row 1 -column 3 -sticky news -padx 3 -pady 3
.wleft.b41 configure -state [lindex $listacti 10]
button .wleft.b42 -image [image create photo -file sysdata/b14.jpg] -background #ffff80 -command "lanceappli associe11.tcl 1" -bd 4 -height 90 -width 90
grid .wleft.b42 -row 2 -column 3 -sticky news -padx 3 -pady 3
.wleft.b42 configure -state [lindex $listacti 11]
if {$sound != 0} {
button .wleft.b43 -image [image create photo -file sysdata/b16.jpg] -background #ffff80 -command "lanceappli associe12.tcl 1" -bd 4 -height 90 -width 90
grid .wleft.b43 -row 3 -column 3 -sticky news -padx 3 -pady 3
.wleft.b43 configure -state [lindex $listacti 12]
}
button .wleft.b51 -image [image create photo -file sysdata/b5.jpg] -background #ffff80 -command "lanceappli associe4.tcl 1" -bd 4 -height 90 -width 90
grid .wleft.b51 -row 1 -column 4 -sticky news -padx 3 -pady 3
.wleft.b51 configure -state [lindex $listacti 13]
button .wleft.b52 -image [image create photo -file sysdata/b6.jpg] -background #ffff80 -command "lanceappli associe14.tcl 1" -bd 4 -height 90 -width 90
grid .wleft.b52 -row 2 -column 4 -sticky news -padx 3 -pady 3
.wleft.b52 configure -state [lindex $listacti 14]
button .wleft.b53 -image [image create photo -file sysdata/b10.jpg] -background #ffff80 -command "lanceappli associe5.tcl 1" -bd 4 -height 90 -width 90
grid .wleft.b53 -row 3 -column 4 -sticky news -padx 3 -pady 3
.wleft.b53 configure -state [lindex $listacti 15]
button .wleft.b54 -image [image create photo -file sysdata/b11.jpg] -background #ffff80 -command "lanceappli associe6.tcl 1" -bd 4 -height 90 -width 90
grid .wleft.b54 -row 4 -column 4 -sticky news -padx 3 -pady 3
.wleft.b54 configure -state [lindex $listacti 16]
button .wleft.b61 -image [image create photo -file sysdata/b12.jpg] -background #ffff80 -command "lanceappli associe7.tcl 1" -bd 4 -height 90 -width 90
grid .wleft.b61 -row 1 -column 5 -sticky news -padx 3 -pady 3
.wleft.b61 configure -state [lindex $listacti 17]
if {$sound != 0} {
button .wleft.b62 -image [image create photo -file sysdata/b15.jpg] -background #ffff80 -command "lanceappli associe8.tcl 1" -bd 4 -height 90 -width 90
grid .wleft.b62 -row 2 -column 5 -sticky news -padx 3 -pady 3
.wleft.b62 configure -state [lindex $listacti 18]
}

#set myimage [image create photo -file sysdata/background.gif]
#label .wcenter.imagedisplayer -image $myimage -background blue
#pack .wcenter.imagedisplayer -side top

}


############
# Bindings #
############
bind . <Control-q> {exit}


proc changeinterface {} {
global categorie repbasecat baseHome Home
variable demarre
variable repertcat
changehome
set demarre "Aucune"
set categorie $demarre
set repbasecat "cat_francais"
set repertcat $repbasecat
set f [open [file join $baseHome reglages associations.conf] "r"]
set tmp1 [gets $f]
set tmp2 [gets $f]
set tmp3 [gets $f]
set tmp4 [gets $f]
set tmp5 [gets $f]
set tmp6 [gets $f]
close $f
set f [open [file join $baseHome reglages associations.conf] "w"]
puts $f $categorie
puts $f $tmp2
puts $f $tmp3
puts $f $tmp4
puts $f $tmp5
puts $f $repbasecat
close $f
if {![file isdirectory [file join $Home categorie $repbasecat]]} {
	file mkdir [file join $Home categorie $repbasecat]
	}
changecatedefaut
#interface
}


proc lanceappli {appli niveau} {
global iwish
set appli [file join $appli]
exec $iwish $appli $niveau &
}

interface

proc setlang {lang} {
global env plateforme baseHome
set env(LANG) $lang
set f [open [file join $baseHome reglages lang.conf] "w"]
puts $f $lang
close $f

::msgcat::mclocale $lang
::msgcat::mcload [file join [file dirname [info script]] msgs]
interface
}

proc changecatedefaut {} {
global categorie Home baseHome
variable demarre
set ext .cat
set categorie $demarre
if {$categorie == "Aucune"} {
set cattmp "none"
} else {
set cattmp $categorie$ext
}
set f [open [file join $baseHome reglages associations.conf] "r"]
set tmp1 [gets $f]
set tmp2 [gets $f]
set tmp3 [gets $f]
set tmp4 [gets $f]
set tmp5 [gets $f]
set tmp6 [gets $f]
close $f
set f [open [file join $baseHome reglages associations.conf] "w"]
puts $f $cattmp
puts $f $tmp2
puts $f $tmp3
puts $f $tmp4
puts $f $tmp5
puts $f $tmp6
close $f

interface
}


proc setpolice {} {
global categorie Home baseHome
variable police
set f [open [file join $baseHome reglages associations.conf] "r"]
set tmp1 [gets $f]
set tmp2 [gets $f]
set tmp3 [gets $f]
set tmp4 [gets $f]
set tmp5 [gets $f]
set tmp6 [gets $f]
close $f
set f [open [file join $baseHome reglages associations.conf] "w"]
puts $f $tmp1
puts $f $police
puts $f $tmp3
puts $f $tmp4
puts $f $tmp5
puts $f $tmp6
close $f

}
