############################################################################
# Copyright (C) 2002 David Lucardi
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,USA.
############################################################################
# File  : fichier.php
# Author  : David Lucardi
#           mailto: DavidLucardi@aol.com
# Date    : 26/04/2002
# Licence : GNU/GPL Version 2 ou plus
#
# Description:
# ------------
#
# @version    $Id: associe15.tcl,v 1.2 2004/04/20 15:11:48 erics Exp $
# @author     David Lucardi
# @project
# @copyright  David Lucardi 26/04/2002
#
#
#########################################################################
#!/bin/sh
#associe11.tcl
# Licence : GNU/GPL Version 2 ou plus
# \
exec wish "$0" ${1+"$@"}

###########################################################
#alear : tableau d'int pour le mlange
#etiqarr :tableau pour recevoir les syllabes
#imgarr : tableau pour recevoir les images
#font2 : police de caractre
#listdata : donnes du jeu, dans une liste
#bgl, bgn : couleurs utilises
#nbreu index de l'item en cours
#listeval :liste pour collecter les informations pour les fiches bilan
#categorie : variable pour la categorie
#user : variable pour le nom de l'utilisateur
#flag : dtection de rentrance dans le survol des objets, pour la gestion du son 
#nb : nombre total d'item du jeu en cours
#niveau : gestion du passage au niveau de difficult suprieur

#variables
source fonts.tcl
source path.tcl
source msg.tcl
source eval.tcl


global alear imgarr etiqarr bgn bgl nb font2 listdata listeval categorie user flag nbreu niveau repbasecat Home sound baseHome
set c .frame.c
set bgn #ffff80
set bgl #ff80c0
set flag 0
set niveau 0
set catedefaut ""
set font2 ""
set son 1

set ident $tcl_platform(user)
set plateforme $tcl_platform(platform)
initlog $plateforme $ident
inithome

#interface
. configure -background #ffff80 
frame .frame -width 640 -height 380 -background #ffff80
pack .frame -side top -fill both -expand yes
wm geometry . +0+0
canvas $c -width 640 -height 380 -background $bgn -highlightbackground #ffff80
pack $c
frame .bframe -background #ffff80
pack .bframe -side bottom
for {set i 1} {$i < 9} {incr i 1} {
label .bframe.lab$i -background #ffff80 -width 4
grid .bframe.lab$i -column [expr $i -1] -row 1 -sticky e
}
label .bframe.lab22 -background #ffff80 -text [mc {Clique sur une oreille.}]
grid .bframe.lab22 -column $i -padx 1 -row 1
button .bframe.b2 -image [image create photo imagbut -file [file join sysdata again2.gif] ] -background #ff80c0 
grid .bframe.b2 -column [expr $i + 1] -padx 1  -row 1 -sticky w
#button .bframe.b3 -image [image create photo suitebut -file [file join sysdata suite.gif]] -background #ff80c0
#grid .bframe.b3 -column [expr $i + 2] -padx 1  -row 1 -sticky w

#Rcupration donnes gnrales dans associations.conf
catch {set f [open [file join $baseHome reglages associations.conf] "r"]
set catedefaut [gets $f]
set font2 [gets $f]
set son [gets $f]
set tmp [gets $f]
set tmp [gets $f]
set repbasecat [gets $f]
close $f}


if {$font2 == "none" || $font2 == ""} {
set font2 {Arial 20 bold}

} else {
set font2 \173$font2\175\04020\040bold
}

#dtection possibilit son (variable sound, et paramtre d'activation du son : son)
#global sound
if {$sound == 0} {
tk_messageBox -message [mc {Ce jeu necessite le support du son. Veuillez installer le package snack.}] -type ok -icon info 
exit
}

catch {
set f [open [file join $baseHome reglages son.conf] "r"]
set sson [gets $f]
close $f
set sound [expr $sound && [lindex $sson 7]]
}


proc init {c} {
global catedefaut listdata categorie Home font2 repbasecat Home tabrep sonref paramson getcat listeval
array unset tabrep
set listdata ""
if {$catedefaut == "none" || $catedefaut == ""} {
opencat
catch {destroy .opencate}
set ext .cat
set file $getcat$ext
 } else {
set file $catedefaut
}

wm title . "[mc {J'entends, je n'entends pas - }]$file" 

.bframe.b2 configure -command "recommence $c"
#.bframe.b3 configure -command "suite $c"

#if {[catch { set f [open [file join $Home categorie $repbasecat $file] "r" ] }] } {

#      set answer [tk_messageBox -message [mc {Erreur de fichier.}] -type ok -icon info] 
 #     exit
#}

set f [open [file join $Home categorie $repbasecat $file] "r" ]
if {[catch {set listdata [gets $f]}]} {
     set answer [tk_messageBox -message [mc {Erreur de fichier.}] -type ok -icon info]
     close $f
     exit
     } else {
     close $f
     }



for {set i 1} {$i <= [llength $listdata]} {incr i 1} {
    set tabrep([lindex [lindex $listdata [expr $i - 1] ] 0]) 1
    }

set pre "non_"
if {[catch { set f [open [file join $Home categorie $repbasecat $pre[file tail $file]] "r" ] }] } {

      set answer [tk_messageBox -message [mc {Le fichier complementaire necessaire pour cet exercice n'a pas ete trouve}]  -type ok -icon info] 
      exit
}
if {[catch {set listdata [concat $listdata [gets $f]]}]} {
     set answer [tk_messageBox -message [mc {Erreur de fichier.}] -type ok -icon info]
     close $f
     exit
     } else {
     close $f
     }

for {set k [expr $i]} {$k <= [llength $listdata]} {incr k 1} {
    set tabrep([lindex [lindex $listdata [expr $k - 1] ] 0]) 0
    }


set categorie [lindex [split [lindex [split $file /] end] .] 0]
set listeval \173[mc {J'entends, je n'entends pas - }]\175\040$categorie

set cate $categorie
set cate [supnum $cate]

catch {
set ext ".dat"
set f [open [file join $Home categorie $repbasecat $cate$ext] "r" ] 
set tmp [gets $f]
set sonref [lindex $tmp 0]
set paramson [lindex $tmp 1]
close $f
}

main $c
}

#procdures
##########################################################"""""
proc recommence {c} {
global listeval user catedefaut
#enregistreval
lappend listeval "4 \173Exercice recommenc\175"
if {$catedefaut != ""} {main $c}

}

proc melange {bas haut} {
global alear nb
set diff [expr $haut - $bas]
for {set i $bas} {$i < $haut} {incr i 1} {
  set alear($i) $i
  }
for {set i 1} {$i < $nb} {incr i 1} {
  set t1 [expr int(rand()*$diff) + 1]
  set t2 [expr int(rand()*$diff) + 1]
  set temp $alear($t1)
  set alear($t1) $alear($t2)
  set alear($t2) $temp
  }
}


##############################################################"""
proc main {c} {
#nbessai nombre de tentatives sur l'item en cours
#score : calcul du pourcentage de russite de l'lve

global alear imgarr etiqarr bgn bgl nbreu font2 nb listdata nbessai listeval categorie score catedefaut
set nbessai 0
set nbreu 1
set score 0

set font1 {Helvetica 12}
set catedefaut $categorie
#set tmp [mc {J'entends, je n'entends pas - }]
#set listeval \173$tmp\175\040$categorie

#on mlange les associations
set leng [llength $listdata]
for {set i 1} {$i <= $leng} {incr i 1} {
   set t1 [expr int(rand()*$leng)]
   set t2 [expr int(rand()*$leng)]
   set tmp [lindex $listdata $t1]
   set listdata [lreplace $listdata $t1 $t1 [lindex $listdata $t2]]
   set listdata [lreplace $listdata $t2 $t2 $tmp]
   }
#pas plus de huit associations dans le jeu
if {$leng > 8 } {
   set nb 8
   } else {
   set nb $leng
   }
#cration de la barre de progression
image create photo pbien -file [file join sysdata pbien.gif] 
image create photo ppass -file [file join sysdata ppass.gif]
image create photo pmal -file [file join sysdata pmal.gif]
image create photo pneutre -file [file join sysdata pneutre.gif]

image create photo oreille0 -file [file join sysdata entends.gif] 
image create photo oreille1 -file [file join sysdata entends1.gif]
image create photo pasoreille0 -file [file join sysdata entendspas.gif]
image create photo pasoreille1 -file [file join sysdata entendspas1.gif]
image create photo speaker -file [file join sysdata speaker.gif]

for {set i 1} {$i <= $nb} {incr i 1} {
.bframe.lab$i configure -image pneutre -width 30
}

#stockage des images dans un tableau
for {set i 1} {$i <= $nb} {incr i 1} {
    set imgarr($i) [lindex [lindex $listdata [expr $i - 1] ] 0]
    }
#appel de la procdure principale
place $c
}

proc soundEnter {c} {
global imgarr flag nbreu repbasecat Home
if {$flag == 0 } {
    set ext .wav
    set son [lindex [split $imgarr($nbreu) .] 0]
    enterstart [file join $Home categorie $repbasecat $son$ext]
   }
}

#######################################"
proc place {c} {
global alear imgarr etiqarr bgn bgl nbreu font2 nb listdata nbessai listeval categorie bonnereponse Home tabrep

$c delete all
set bonnereponse [lindex [lindex $listdata [expr $nbreu - 1] ] 2]
image create photo kimage1 -file [file join $Home images $imgarr($nbreu)] -width 130 -height 130
$c create image 490 250 -image speaker -tags "speaker"
set xpos 200
set ypos 150
$c create image $xpos $ypos -image kimage1 -tags img
$c create image [expr $xpos - 60] [expr $ypos + 120] -image oreille1 -tags "entendsvrai"
$c create image [expr $xpos + 60] [expr $ypos + 120] -image pasoreille1 -tags "entendsfaux"
$c bind entendsvrai <Any-Enter> "catch {$c delete withtag figure} \n $c itemconf entendsvrai -image oreille0"
$c bind entendsvrai <Any-Leave> "$c itemconf entendsvrai -image oreille1"
$c bind entendsfaux <Any-Enter> "catch {$c delete withtag figure} \n $c itemconf entendsfaux -image pasoreille0"
$c bind entendsfaux <Any-Leave> "$c itemconf entendsfaux -image pasoreille1"
$c bind entendsvrai <1> "verif $c 1"
$c bind entendsfaux <1> "verif $c 0"
$c bind speaker <Any-Enter> "Soundspeakerin"
$c bind speaker <Any-Leave> "Stop"

soundEnter $c
#$c create text [expr $xpos - 20] [expr $ypos + 70] -text "_______" -anchor n -tags cible1 -font $font2 -fill $bgl
}

#appel principal
init $c

#gestion des vnements
bind . <Destroy> "quitte"
if {$sound == 1} {
$c bind img <Any-Enter> "soundEnter $c"
$c bind img <Any-Leave> "soundLeave $c"
}

#gestion du son
proc Stop {} {
 enterstop
}

proc Soundspeakerin {} {
global sonref Home categorie repbasecat
    enterstart [file join $Home categorie $repbasecat $sonref]
}


proc soundLeave {c} {
enterstop
}


proc majbilan {} {
global bonnereponse nbreu listeval score nbessai
        switch $nbessai {
                1 {.bframe.lab$nbreu configure -image pbien -width 30
                lappend listeval 1\040\173$bonnereponse\175
                incr score 10
                }
                2 {.bframe.lab$nbreu configure -image pmal -width 30
                lappend listeval 3\040\173$bonnereponse\175
                #incr score 5
                }
                default {.bframe.lab$nbreu configure -image pmal -width 30
                lappend listeval 3\040\173$bonnereponse\175

                }
         }

}

#gestion du jeu
proc verif {c num} {
global nbreu nb alear imgarr listdata nbessai listeval etiqarr user niveau categorie score repbasecat Home tabrep catedefaut bonnereponse font2
#dtermination du tag de l'tiquette que l'on a dplac, des coordonnes de l'tiquette, des coordonnes de la cible
    incr nbessai
# test pour savoir si c'est ok
	if {$tabrep([lindex [lindex $listdata [expr $nbreu -1] ] 0]) == $num} {
          #bell              
         # si c'est ok et que le jeu est fini
          if {$nbreu==$nb} {
		catch {$c delete withtag figure}
             $c create text 470 140 -text [mc {Bravo!!}] -font {Arial 24}
	       $c create text 200 30 -text $bonnereponse -anchor n -tags figure -font $font2
             update
             after 2000
             $c delete all
             #on met  jour la fiche bilan
		 majbilan
##########################################################"""""""
           #calcul du score            
            set score [expr $score*10/$nb]
           set pourcent %
           $c create text 200 100 -text "[mc {Score : }] $score\040$pourcent" -font {Arial 24}
            #test pour savoir si on passe au niveau suivant et dtermination du niveau  faire
            if {$score >= 75} { 
            update
            after 2000
            set file $categorie
            set niveau ""
            for {set i 1} {$i <= [string length $file]} {incr i 1} {
               if {[string match {[0-9]} [string index $file end]] == 1} {
                 set niveau [string index $file end]$niveau
                 set  file [string range $file 0 [expr [string length $file] -2] ]
                }
            }
            if {$niveau == ""} {
            set niveau 0
            }
            incr niveau
            set ext .cat
            set file $file$niveau$ext
            if {[catch {set f [open [file join $Home categorie $repbasecat $file] "r"]} ]} {
            $c create text 200 200 -text [mc {C'est fini!}] -font {Arial 24}
            } else {
            #si un autre niveau est requis
            ##set listdata [gets $f]
            close $f
            enregistreval
            set categorie [lindex [split [lindex [split $file /] end] .] 0]
		#lappend listeval "4 \{[mc {J'entends, je n'entends pas - }] $categorie\}"
		set catedefaut $file
		for {set i 1} {$i < 9} {incr i 1} {
		.bframe.lab$i configure -image "" -width 1
		}

            init $c
            }
            } else {
#s'il n'y a pas de niveau suprieur disponible
            $c create text 200 200 -text [mc {C'est fini!}] -font {Arial 24}
            }
################################################################

            return
            }
#si on n'est pas  la fin du jeu en cours mais que c'est juste
          majbilan
          set nbessai 0
          image create photo figure -file [file join sysdata bien.gif]
	    $c create image 490 140 -image figure -tags figure
	    $c create text 200 30 -text $bonnereponse -anchor n -tags figure -font $font2
          update
          after 2000         
          catch {$c delete withtag figure}
          incr nbreu
          place $c
          return
	    } else {  
#si c'est faux       
          image create photo figure -file [file join sysdata mal.gif]
	    $c create image 490 140 -image figure -tags figure
          }
     
 }




proc suite {c} {
global catedefaut
enregistreval
$c delete all
set catedefaut ""
init $c
}









